
require("3ds")
require("badboys")

--if love.system.getOS() ~= "3ds" then
--	love.math.setRandomSeed(os.time()) -- To make random things actually random... a bit... a little bit more at least. Doesn't work on 3ds
--end
---------------------------------------
function love.load()
load_bots:load()

test_bg = love.graphics.newImage( "grafiken/test_bg.png")

	x = -100
	y = -100
	
	shoot_time = 0
	shoote_space = 10

	bullets = {}
	bulletSpeed = 150
	max_bullets = 10
	ammo = 200
	
	
	player_width = 10
	player_height = 10
	player_obj_x = (400/2)-(player_width/2)
	player_obj_y = (240/2)-(player_height/2)
	player_x = 0
	player_y = 0
	player_speed = 100

	
	




end -- End Load
---------------------------------------



---------------------------------------

function love.mousereleased(x, y, button)
	if button == 1 or button == 2 or button == 3 or button == 4 or button == 5 then
		allow_shoot = false
	end
end

function love.keypressed(key)

	if key == "f" then
		ammo = ammo+10
	end


	if key == "start" then
		love.event.quit()
	end


end  -- End KeyCheck

	
---------------------------------------




--------------------------------------------



---------------------------------------
function love.update(dt)
bots_ki:update(dt)

	-- Get Aim Position
	if love.mouse.isDown(1,2,3,4,5) then
		x = love.mouse.getX()*1.25
		y = love.mouse.getY()
	end
	
		-- Define the Space between the Bullets
		shoot_time = shoot_time+1
		if shoot_time == 1 then
			allow_shoot = true
		elseif shoot_time == 2 then
			allow_shoot = false
		elseif shoot_time == shoote_space then
			shoot_time = 0
		end
	
	
	-- Shooting stuff
	if allow_shoot and love.mouse.isDown(1,2,3,4,5) and ammo > 0 then
		local startX = player_obj_x + player_width / 2
		local startY = player_obj_y + player_height / 2
		local mouseX = x
		local mouseY = y
 
		local angle = math.atan2((mouseY - startY), (mouseX - startX))
 
		local bulletDx = bulletSpeed * math.cos(angle)
		local bulletDy = bulletSpeed * math.sin(angle)
 
		table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy})
		
		ammo = ammo-1
	end
	-- Moving Bullets
	for i,v in ipairs(bullets) do
		v.x = v.x + (v.dx * dt)
		v.y = v.y + (v.dy * dt)
	end
	
	-- 3DS have max array size, so this needs to be done to reset the array, have to be done smoother(check)
	if #bullets < 0 then
		if bullets[#bullets].x >= 410 then
			bullets = {}
		elseif bullets[#bullets].x <= -10 then
			bullets = {}
			elseif bullets[#bullets].y >= 250 then
			bullets = {}
		elseif bullets[#bullets].y <= -10 then
			bullets = {}
		end
	end
	
	
	
	-- Move Player
	if love.keyboard.isDown("cpadleft") or love.keyboard.isDown("a") then
		player_x = player_x-player_speed*dt
	end
	if love.keyboard.isDown("cpadright") or love.keyboard.isDown("d") then
		player_x = player_x+player_speed*dt
	end	
	if love.keyboard.isDown("cpadup") or love.keyboard.isDown("w") then
		player_y = player_y-player_speed*dt
	end
	if love.keyboard.isDown("cpaddown") or love.keyboard.isDown("s") then
		player_y = player_y+player_speed*dt
	end
	



end -- End Update
---------------------------------------



---------------------------------------
function love.draw()



	love.graphics.setScreen("bottom")

	
	
	love.graphics.setScreen("top")
	--love.graphics.draw(test_bg , 0 , 0)
	
	draw_bots:draw()
	
	love.graphics.setColor(255,0,0 )
	love.graphics.rectangle( "fill", x , y , 2, 2 )

	love.graphics.setColor(0,0,255 )
	love.graphics.rectangle( "fill", player_obj_x , player_obj_y , player_width, player_height )
	

	
	love.graphics.setColor(255,255,0 )
	for i,v in ipairs(bullets) do
		love.graphics.rectangle("fill", v.x, v.y, 2,2)
	end
	
	
	-- Debug Stuff
	love.graphics.setColor(255,255,255 )
	love.graphics.print(bot_x, 10, 10)
	love.graphics.print(bot_y, 10, 25)
	love.graphics.print(player_x, 10, 40)
	love.graphics.print(player_y, 10, 55)
	if #bullets >= 1 then
	love.graphics.print(ammo, 10, 70)
	end



end -- End Draw
---------------------------------------

