
require("3ds")
require("badboys")
require("collisions")


if love.system.getOS() ~= "3ds" then
--	love.math.setRandomSeed(os.time()) -- To make random things actually random... a bit... a little bit more at least. Doesn't work on 3ds
	love.mouse.setVisible(false)
end
---------------------------------------
function love.load()
load_bots:load()




	-- Load Graphics
	test_bg = love.graphics.newImage( "grafiken/test_bg.png")
	ship = love.graphics.newImage( "grafiken/ship.png")
	ship_glow = love.graphics.newImage( "grafiken/ship_glow.png")
	bullet = love.graphics.newImage( "grafiken/bullet.png")
	bullet_glow = love.graphics.newImage( "grafiken/bullet_glow.png")



	x = -100
	y = -100
	
	shoot_time = 0
	shoote_space = 7

	bullets = {}
	bulletSpeed = 500
	max_bullets = 10
	bullet_size = 7
	damage = 100
	ammo = 200
	
	
	player_size = 10
	player_x = (400/2)-(player_size/2)
	player_y = (240/2)-(player_size/2)
	player_speed = 100

	testvar = 0
	



end -- End Load
---------------------------------------



---------------------------------------

function love.mousereleased(x, y, button)
	if button == 1 or button == 2 or button == 3 or button == 4 or button == 5 then
		allow_shoot = false
	end
end

function love.keypressed(key)

	if key == "f" then
		ammo = ammo+10
	end


	if key == "start" then
		love.event.quit()
	end


end  -- End KeyCheck

	
---------------------------------------




--------------------------------------------



---------------------------------------
function love.update(dt)
bots_ki:update(dt)
bullet_coll:update(dt)



	-- Everythging About Shooting Bullets 
	-- Get Aim Position
--	if love.mouse.isDown(1,2,3,4,5) then
		x = love.mouse.getX()*1.25
		y = love.mouse.getY()
--	end
	
		-- Define the Space between the Bullets
		shoot_time = shoot_time+1
		if shoot_time == 1 then
			allow_shoot = true
		elseif shoot_time == 2 then
			allow_shoot = false
		elseif shoot_time == shoote_space then
			shoot_time = 0
		end
	
	
	-- Shooting stuff
	if allow_shoot and love.mouse.isDown(1,2,3,4,5) and ammo > 0 then
		local startX = player_x + player_size/4
		local startY = player_y + player_size/4
		local mouseX = x
		local mouseY = y
 
		angle = math.atan2((mouseY - startY), (mouseX - startX))
 
		local bulletDx = bulletSpeed * math.cos(angle)
		local bulletDy = bulletSpeed * math.sin(angle)
 
		table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy, visible = true})
		
		ammo = ammo-1
	end
	-- Moving Bullets
	for i,v in ipairs(bullets) do
		v.x = v.x + (v.dx * dt)
		v.y = v.y + (v.dy * dt)
	end
	
	-- 3DS have max array size, so this needs to be done to reset the array, have to be done smoother(check)
	if ammo <= 0 then
		if bullets[#bullets].x >= 410 then
			bullets = {}
			ammo = ammo+200
		elseif bullets[#bullets].x <= -10 then
			bullets = {}
			ammo = ammo+200
		elseif bullets[#bullets].y >= 250 then
			bullets = {}
			ammo = ammo+200
		elseif bullets[#bullets].y <= -10 then
			bullets = {}
			ammo = ammo+200
		end
	end
	-- End Shooting Bullets
	
	
	
	-- Move Player
	if love.keyboard.isDown("cpadleft") or love.keyboard.isDown("a") then
		if player_x >= 0 then
			player_x = player_x-player_speed*dt
		end
	end
	if love.keyboard.isDown("cpadright") or love.keyboard.isDown("d") then
		if player_x <= 400-player_size then
			player_x = player_x+player_speed*dt
		end
	end	
	if love.keyboard.isDown("cpadup") or love.keyboard.isDown("w") then
		if player_y >= 0 then
			player_y = player_y-player_speed*dt
		end
	end
	if love.keyboard.isDown("cpaddown") or love.keyboard.isDown("s") then
		if player_y <= 240-player_size then
			player_y = player_y+player_speed*dt
		end
	end
	



end -- End Update
---------------------------------------



---------------------------------------
function love.draw()
love.graphics.setBackgroundColor( 10, 10, 10 )
-- TEst Stuff !!!!
--draw_anim:draw()
 
-----------------

	love.graphics.setScreen("bottom")

	
	
	love.graphics.setScreen("top")
	--love.graphics.draw(test_bg , 0 , 0)
	--Draw Bots
	draw_bots:draw()
	
	-- Draw Mouse
	love.graphics.setColor(255,0,0 )
	love.graphics.rectangle( "fill", x , y , 2, 2 )
	-- Draw Ship
	love.graphics.setColor(255,255,255 )
	love.graphics.draw(ship_glow , player_x-33/3 , player_y-33/3,angle)
	love.graphics.draw(ship , player_x , player_y,angle)
	--love.graphics.rectangle( "fill", player_x , player_y , player_size, player_size )
	

	
	-- Drawing Bullets
	love.graphics.setColor(255,255,0 )
	for i,v in ipairs(bullets) do
		if v.visible then
			love.graphics.draw(bullet_glow , v.x-21/3, v.y-21/3,angle)
			love.graphics.draw(bullet , v.x , v.y,angle)
		end
	end
	
	
	-- Debug Stuff
	love.graphics.setScreen("bottom")
	
	ammo_p = math.ceil(320*(ammo/200)) -- Holy shit, that was harder as i should be for a 22yo ....
	love.graphics.rectangle( "fill",(320/2)-(ammo_p/2),0,ammo_p, 5 ) -- Drawing the Boost Bar
	
	love.graphics.setColor(255,255,255 )
	love.graphics.print(x, 10, 10)
	love.graphics.print(y, 10, 25)
	love.graphics.print(player_x, 10, 40)
	--love.graphics.print(#ex_pos, 10, 55)

	
	
	
	




end -- End Draw
---------------------------------------

-- Dont forget to get cretis to xiode